
#include <stdio.h>
#include <stdlib.h>
#include "input.h"

struct input_s
{
    int quit_requested;
    int pause_requested;
};

input_t *input_new( void )
{
    input_t *in = (input_t *) malloc( sizeof( input_t ) );

    in->quit_requested = 0;
    in->pause_requested = 0;
    return in;
}

void input_delete( input_t *in )
{
    free( in );
}

void input_callback( input_t *in, InputEvent command, int arg )
{
    if( command == I_QUIT ) {
        in->quit_requested = 1;
    } else if( command == I_KEYDOWN ) {
        if( arg == 'p' ) {
            in->pause_requested = 1;
        } else if( arg == I_ESCAPE || arg == 'q' ) {
            in->quit_requested = 1;
        }
    }
}


int input_quit_requested( input_t *in )
{
    return in->quit_requested;
}

int input_pause_requested( input_t *in )
{
    return in->pause_requested;
}

void input_next_frame( input_t *in )
{
    in->quit_requested = 0;
    in->pause_requested = 0;
}

